/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.core;

/**
 * NumericUtil provides numeric utilities
 * 
 * @author Samppa Saarela
 * @version $Id: NumericUtil.java 5487 2009-04-24 08:49:46Z tiwe $
 */
public class NumericUtil {

    final static char[] digits = { '0', '1', '2', '3', '4', '5', '6', '7', '8',
            '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L',
            'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y',
            'Z',

            '_', '-',

            'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
            'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z' };

    /**
     * @param i
     * @param radix
     * @return
     */
    public static String toString(long i, int radix) {
        // if (radix < 2 || radix > digits.length)
        // radix = 10;

        char[] buf = new char[65];
        int charPos = 64;
        boolean negative = (i < 0);

        if (!negative) {
            i = -i;
        }

        while (i <= -radix) {
            buf[charPos--] = (char) i;// digits[(int)(-(i % radix))];
            i = i / radix;
        }
        buf[charPos] = (char) i;// digits[(int)(-i)];

        if (negative) {
            buf[--charPos] = '-';
        }

        return new String(buf, charPos, (65 - charPos));
    }
}
