/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.core;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Replacer provides
 * 
 * @author Samppa Saarela
 * @version $Id: Replacer.java 5487 2009-04-24 08:49:46Z tiwe $
 */
public class Replacer {
    /**
     * @param args
     */
    public static void main(String[] args) {
        try {
            System.out.println(replace(args[0], args[1], new FileReader(args[2])));
        } catch (FileNotFoundException e1) {
            System.err.println("File not found: " + args[2]);
        } catch (IndexOutOfBoundsException e2) {
            System.err.println("Usage: java Replacer <regex> <replacement> <input>\n");
        } catch (IOException e) {
            System.err.println("Unable to read from " + args[2]);
        }
    }

    /**
     * @param regex
     * @param replacement
     * @param in
     * @return
     * @throws IOException
     */
    public static String replace(String regex, String replacement, Reader in)
            throws IOException {
        StringBuilder sb = new StringBuilder();
        int c = in.read();
        while (c != -1) {
            sb.append((char) c);
            c = in.read();
        }
        return replace(regex, replacement, sb.toString());
    }

    /**
     * @param regex
     * @param replacement
     * @param in
     * @return
     */
    public static String replace(String regex, String replacement, String in) {
        List<Object> parts = new LinkedList<Object>();
        Pattern p = Pattern.compile("\\\\(\\d+)");
        Matcher m = p.matcher(replacement);
        StringBuffer sb = null;
        while (m.find()) {
            sb = new StringBuffer();
            m.appendReplacement(sb, "");
            parts.add(sb.toString());
            parts.add(new Integer(m.group(1)));
        }
        sb = new StringBuffer();
        m.appendTail(sb);
        parts.add(sb.toString());

        p = Pattern.compile(regex);
        m = p.matcher(in);
        sb = new StringBuffer();
        while (m.find()) {
            StringBuffer r = new StringBuffer();
            for (Iterator<Object> iter = parts.iterator(); iter.hasNext();) {
                Object part = iter.next();
                if (part instanceof String) {
                    r.append(part.toString());
                } else {
                    r.append(m.group(((Integer) part).intValue()));
                }
            }
            m.appendReplacement(sb, r.toString());
        }
        m.appendTail(sb);

        return sb.toString();
    }
}
