/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.core;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;

/**
 * StringUtil provides
 *
 * @author Timo Westk&auml;mper
 * @version $Id: StringUtil.java 5487 2009-04-24 08:49:46Z tiwe $
 */
public class StringUtil {
               
    /**
     * @param text
     * @param algorithm
     * @return
     */
    public static String getHash(String text, String algorithm){
        return getHash(text, algorithm, 16);
    }
    
    /**
     * @param text
     * @param algorithm
     * @param radix
     * @return
     */
    public static String getHash(String text, String algorithm, int radix){
        MessageDigest md = null;

        try {
            // first create an instance, given the provider
            md = MessageDigest.getInstance(algorithm);
        } catch (Exception e) {
            throw new RuntimeException("Caught " + e.getClass().getName(), e);
        }

        md.reset();

        // call the update method one or more times
        // (useful when you don't know the size of your data, eg. stream)
        try {
            md.update(text.getBytes("UTF-8"));
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException("Caught " + e.getClass().getName(), e);            
        }

        // now calculate the hash
        byte[] encodedText = md.digest();

        StringBuilder buf = new StringBuilder();

        for (int i = 0; i < encodedText.length; i++) {
            if ((encodedText[i] & 0xff) < 0x10) {
                buf.append("0");
            }

            buf.append(Long.toString(encodedText[i] & 0xff, radix));
        }

        return buf.toString();
    }
        
    /**
     * @param joinString
     * @param elements
     * @return
     */
    public static String join(String joinString, Iterable<String> elements){
        StringBuilder buffer = new StringBuilder();
        for (String domain : elements){
            if (buffer.length() > 0) buffer.append(joinString);
            buffer.append(domain);
        }
        return buffer.toString();
    }
    
    
}
