/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.core.collection;

import java.util.Enumeration;
import java.util.Iterator;

/**
 * EnumerationAsIterator provides
 *
 * @author Timo Westk&auml;mper
 * @version $Id: EnumerationAsIterator.java 5487 2009-04-24 08:49:46Z tiwe $
 */
public class EnumerationAsIterator<T> implements Iterator<T>{

    private final Enumeration<T> e;
    
    /**
     * @param e
     */
    public EnumerationAsIterator(Enumeration<T> e){
        this.e = e;
    }
    
    public boolean hasNext() {
        return e.hasMoreElements();
    }

    public T next() {
        return e.nextElement();
    }

    public void remove() {
        throw new UnsupportedOperationException();
        
    }

}
