/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.core.collection;

import java.util.HashMap;
import java.util.Map;

/**
 * FactoryMap provides
 *
 * @author Timo Westk&auml;mper
 * @version $Id: FactoryMap.java 5487 2009-04-24 08:49:46Z tiwe $
 */
public abstract class FactoryMap<K,V>{
    
    private final Map<K,V> cache = new HashMap<K,V>();
    
    public final V get(K key){
        if (cache.containsKey(key)){
            return cache.get(key);
        }else{
            V value = create(key);
            cache.put(key, value);
            return value;
        }
    }
    
    /**
     * factory method for creation of the mapped value for the given key
     * 
     * @param key
     * @return
     */
    protected abstract V create(K key);
    
    public void clear(){
        cache.clear();
    }

}
