/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.core.collection;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * MapFactory provides factory methods for Maps
 * 
 * @author Samppa Saarela
 * @version $Id: MapFactory.java 5487 2009-04-24 08:49:46Z tiwe $
 */
public class MapFactory {

    /**
     * @param <K>
     * @param <V>
     * @param values
     * @param defaults
     * @return
     */
    public static <K, V> Map<K, V> mergedMap(Map<K, V> values,
            Map<K, V> defaults) {
        Map<K, V> map = new LinkedHashMap<K, V>(defaults);
        map.putAll(values);
        return map;
    }

}
